#-----------------------------------------------------------------------------
# Copyright:   (c) 2009 Song Huang <songhuang.tw@gmail.com>
# Created:     2005/05/01
# License:     GPL version 2
#-----------------------------------------------------------------------------

"""
Plone Creative Commons Installation script

 id:            cmf_install_plonecc
 title:         
 module name:   PloncCreativeCommons.Install
 function name: install
"""

from cStringIO import StringIO
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.PloneCreativeCommons import plonecc_globals
from Products.PloneCreativeCommons.CCTool import CCTool

def install(self):
    """
    Install Plone Creative Commons to plone site.
    """
    out = StringIO()  
    # add plone cc tool
    if not self._getOb('portal_cc', None):
        cct=CCTool()
        self._setObject('portal_cc',cct,set_owner=0)
        out.write("Added plone cc tool to self.\n")
    else:
        out.write("Reinstall plone cc tool.\n")
    # add skin
    skinstool = getToolByName(self, 'portal_skins')
    skin_name = 'cc'
    if skin_name not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', plonecc_globals)
    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName) 
        path = [i.strip() for i in  path.split(',')]
        if skin_name not in path:
            path.append(skin_name)
        path = ','.join(path)
        skinstool.addSkinSelection(skinName, path)
    out.write("Added cc DirectoryView to portal_skins.\n")
    ## add portlet
    # self.left_slots = list(self.left_slots) + ['here/portlet_cc/macros/portlet',]
    # out.write("Added portlet_cc to left_solts.\n")
    
    # add actionicon
    ai = getToolByName(self, 'portal_actionicons')
    try:
        ai.removeActionIcon('controlpanel', 'plonecc')
    except KeyError:
        pass
    try:
        ai.removeActionIcon('controlpanel', 'ccpreference')
    except KeyError:
        pass
    try:
        ai.removeActionIcon('plone', 'ccll')
    except KeyError:
        pass
    ai.addActionIcon('controlpanel', 'plonecc', 'cc_icon.gif', 'Plone CC')
    ai.addActionIcon('controlpanel', 'ccpreference', 'cc_icon.gif', 'CC Preference')
    ai.addActionIcon('plone', 'ccll', 'cc_icon.gif', 'CC Icon')
    out.write("Added 2 cc action icon to portal_actionicons.\n")
                      
    return out.getvalue()
